/*======================================================================*/
/*                                                                      */
/*      DDGI_Generic_lib_def.h                                          */
/*      Forward declarations of DLL functions, common to ALL DDGI DLLs. */
/*======================================================================*/
/*      J.P.PILLOU      25/08/2012                                      */
/*======================================================================*/      
                                                                     
/*======================================================================*/
/*                         FUNCTION DECLARATIONS                        */
/*======================================================================*/


__declspec (dllexport) HANDLE
        DDGL_Register(          BOOL                    bEnglish,
                                char                    **ppDescString,
                                char                    **ppVersion,
                                char                    *sRailProtocols[],
                                char                    *sFeedbackProtocols[] );

__declspec (dllexport) BOOL
        DDGL_StartServer(       DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_StopServer(        DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayServer(     DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayError(      DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayServerStatus( DGI_SERVER_PARAMS     *pServerParams );

__declspec (dllexport) BOOL
        DDGL_EnableErrorDisplay( DGI_SERVER_PARAMS      *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayStatistics( DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayRcvBuffer(  DGI_SERVER_PARAMS       *pServerParams );

__declspec (dllexport) BOOL
        DDGL_DisplayCmdFifo(    DGI_SERVER_PARAMS       *pServerParams );


__declspec (dllexport) BOOL
        DDGL_GetNextExpectedResponse(
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_RCV_DATA   pGenericRcvData );

__declspec (dllexport) BOOL
        DDGL_GetNextUnexpectedMessage(
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_RCV_DATA   pGenericRcvData );

__declspec (dllexport) BOOL
        DDGL_ResumeOperations(  pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_PowerOff(          pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_EmergencyStop(     pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_StopLoco(          pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_DirectCVRead(      pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_ServiceModeResultRequest(          
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_DirectCVWrite(     pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_CommandStationVersionRequest(          
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_CommandStationVersionStatus(          
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_AccessoryInfoRequest(          
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_DetectorInfoRequest(          
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetAccessoryState( pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_LocoInfoRequest(   pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetSpeed(          pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetF0F12(          pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetF0F4(           pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetF5F8(           pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_SetF9F12(          pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );

__declspec (dllexport) BOOL
        DDGL_OperationModeProgramming(           
                                pDGI_SERVER_PARAMS      pServerParams,
                                pDGI_GENERIC_DATA       pGenericData );


